<script>
import AssistantMessage from "./AssistantCard.vue";
import UserCard from "./UserCard.vue";
import store from '/src/store/store.js'

export default {
  name: "Messages",
  components: {
    AssistantMessage,
    UserCard
  },
  computed: {
    messages() {
      return store.getters.getMessages;
    }
  },
  mounted() {
    this.scrollToBottom();
  },
  watch: {
    messages: {
      deep: true,
      immediate: true,
      handler() {
        this.$nextTick(this.scrollToBottom);
      }
    }
  },
  methods: {
    scrollToBottom() {
      this.$nextTick(() => {
        const container = this.$refs.containerRef;
        container.scrollTop = container.scrollHeight;
      });
    },
  }
}
</script>

<template>

  <div
    class="my-3 d-flex flex-column messages-container justify-end"
    ref="containerRef"
  >
    <v-scrollbar style="max-height: 400px;">
      <div v-for="message in messages">
        <assistant-message
          v-if="message.role === 'assistant'"
          :message="message"
          class="left"
        />
        <user-card
          v-else
          :message="message"
          class="right me-2"
        />
      </div>
    </v-scrollbar>
  </div>

</template>

<style scoped>
.messages-container {
  overflow: auto;
}

.left {
  float: left;
}

.right {
  float: right;
}
</style>